<?php
/**
 * Created by PhpStorm.
 * User: usuario1
 * Date: 24/10/2017
 * Time: 10:27 AM
 */

require_once 'AutoloaderJson.php';

class Autoloader {

    const AUTOLOADER_METHOD = 'Autoloader::AutoloaderFunction';

    private static $tableClassPath = null;

    public static function AutoloadRegister(){
        spl_autoload_register(self::AUTOLOADER_METHOD);
    }

    public static function AutoloadUnregister(){
        spl_autoload_unregister(self::AUTOLOADER_METHOD);
    }

    private static function AutoloaderFunction($class_name) {
        $classFile = self::getClassFilePath($class_name);

        if($classFile) {
            $_ret = include $classFile;

            if (!$_ret)
                throw msgTable::getExceptionFromTableMsgCode (msgTable::EXCEPTION_CLASSLOADER_CLASSNOTFOUND, $classFile);
        }else{
            throw msgTable::getExceptionFromTableMsgCode (msgTable::EXCEPTION_CLASSLOADER_NOENTRYFORCLASS, $class_name);
        }
    }

    private static function setTableClassesPath(){
        self::$tableClassPath = AutoloaderJson::getTableClassPath();
    }

    private static function getClassFilePath($className){
        $ret = null;

        if(self::$tableClassPath === null)
            self::setTableClassesPath();

        if(property_exists(self::$tableClassPath,$className))
            $ret = self::$tableClassPath->$className;

        return $ret;
    }

}