<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

require_once "daoCursorIterator.php";

/**
 * Description of daoResponse
 *
 * @author pc3
 */
class daoResponse {
    
    private $cursor;
    private $affectedRows;
    private $error;
    private $exception;
    
    private $statusResponse;
    
    function __construct($cursor) {
        // todo, instanciar resto de las propiedades en funcion del cursor        
        if (MDB2::isError($cursor)) {
            $this->error = $cursor;
            $this->statusResponse = statusResponse::getInstanceForMDBError($cursor);
        } else {
            $this->statusResponse = statusResponse::getInstanceOk();
            $this->cursor = $cursor;
        }
                   
    }

    function getCursor() {
        return $this->cursor;
    }

    /**
     * @return integer
     */
    function getAffectedRows() {
        return $this->affectedRows;
    }

    function getError() {
        return $this->error;
    }

    function getException() {
        return $this->exception;
    }

    /**
     * @return statusResponse
     */
    function getStatusResponse() {
        return $this->statusResponse;
    }

    function setCursor($cursor) {
        $this->cursor = $cursor;
    }

    function setAffectedRows($affectedRows) {
        $this->affectedRows = $affectedRows;
    }

    function setError($error) {
        $this->error = $error;
    }

    function setException($exception) {
        $this->exception = $exception;
    }

    function setStatusResponse($statusResponse) {
        $this->statusResponse = $statusResponse;
    }
            
    function getNextRow() {
        if (! MDB2::isError($this->cursor))
            $ret = $this->cursor->fetchRow(MDB2_FETCHMODE_ASSOC);
        else 
            $ret = false;
        return $ret;
    }

    /**
     * @return daoCursorIterator
     */
    function getIterator(){
        return new daoCursorIterator($this->cursor);
    }

}
