<?php
/**
 * Created by PhpStorm.
 * User: usuario1
 * Date: 25/10/2017
 * Time: 11:59 AM
 */


class daoPersistRelationItem_oneToMany {

    private $propertyName;
    private $autoInstantiate;
    private $relKey;
    private $className;
    private $object;
    private $modeInDeepInstance;


    function __construct($relation) {
        $this->propertyName = $relation->propertyName;
        $this->autoInstantiate = $relation->autoInstantiate;
        $this->relKey = $relation->relKey;
        $this->className = $relation->className;
        if(property_exists($relation,'modeInDeepInstance'))
            $this->modeInDeepInstance = $relation->modeInDeepInstance;
    }

    function getObject() {
        return $this->object;
    }

    function setObjectForDeepInstance($parentObject){
        $__className = $this->className;

        $objList = new $__className;
        $method = "get" . ucfirst($this->relKey);
        $keyValue = $parentObject->$method();

        // TODO verificar que $keyValue no sea nulo
        if ($keyValue) {

            switch ($this->modeInDeepInstance){
                case daoPersist::MODE_PLAIN:
                    $objList->getPlainInstance($keyValue);
                    break;
                case daoPersist::MODE_DEEP:
                    $objList->getDeepInstance($keyValue);
                    break;
                case daoPersist::MODE_AUTO:
                default:
                    $objList->getInstance($keyValue);
                    break;
            }

            if ($objList->getStatusResponse()->isOk()) {
                $this->object = $objList;
            } else {
                throw msgTable::getExceptionFromTableMsgCode(msgTable::EXCEPTION_DATABASE_DAOPERSISTRELATIONS_NOTFOUND, "$__className#$keyValue");
            }
        }
    }

    function setObject($parentObject) {

        $__className = $this->className;

        $objList = new $__className;
        $method = "get" . ucfirst($this->relKey);
        $keyValue = $parentObject->$method();
        
        // TODO verificar que $keyValue no sea nulo
        if ($keyValue) {
            $objList->getInstance($keyValue);
            if ($objList->getStatusResponse()->isOk()) {
                $this->object = $objList;
            } else {
                throw msgTable::getExceptionFromTableMsgCode(msgTable::EXCEPTION_DATABASE_DAOPERSISTRELATIONS_NOTFOUND, "$__className#$keyValue");
            }
        }
    }

    function setPropertyInParentObject($parentObject) {

        $propertyName = $this->getPropertyName();
        $method = "set" . ucfirst($propertyName);
        // existe el metodo para asignar el objeto
        if (method_exists($parentObject, $method)) {
            $_obj = $this->getObject();


            // el objeto existe
            if (is_object($_obj)) {
                $parentObject->$method($_obj);

            } // TODO que hacer en caso de no instanciar objeto o caso de error
        }
    }

    public function getPropertyName() { return $this->propertyName; }
    public function getAutoInstantiate() { return $this->autoInstantiate; }
    public function getForeignKey() { return $this->foreignKey; }
    public function getRelKey() { return $this->relKey; }
    public function getClassName() { return $this->className; }
    public function setPropertyName($propertyName) { $this->propertyName = $propertyName; }
    public function setAutoInstantiate($autoInstantiate) { $this->autoInstantiate = $autoInstantiate; }
    public function setForeignKey($foreignKey) { $this->foreignKey = $foreignKey; }
    public function setRelKey($relKey) { $this->relKey = $relKey; }
    public function setClassName($className) { $this->className = $className; }

}